// -------------------------------------------------------------------------
// piQa MySearch File Search Tool
// Copyright 2003 - 2008 Ronald D. Grindle. All rights reserved.
// This may use this tool freely, you may pass it on as you wish.
// You may alter the code, as long as you maintain the Copyright statement,
// the statement of use and the piQa string and logo on the user interface.
// -------------------------------------------------------------------------

using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Diagnostics;
using System.Reflection;
using System.Threading;
using System.Windows.Forms;

namespace MySearch
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMySearch : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button butSearch;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog1;
		private System.Windows.Forms.TextBox txtString;
		private System.Windows.Forms.TextBox txtPath;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox comboType;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox chkSub;
		private System.Windows.Forms.CheckBox chkCaseSens;
		private System.Windows.Forms.TextBox txtFound;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.Button butStop;
		private System.Windows.Forms.TextBox txtSearching;

		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.TextBox txtScans;
		private System.Windows.Forms.Label lblPwrdBy;
		private System.Windows.Forms.Button butPiqa;
		private System.Windows.Forms.Label lblSearching;
		private System.Windows.Forms.Label lblScans;
		private System.Windows.Forms.Label lblHits;

		private bool m_Cont;
		private bool m_TypeChg;
		private int m_Count;
		private int m_Hits;
		private int m_LastTypeIx;
		private string m_LastPath;
		private ArrayList m_EditArgLst;
		
		private int m_butSearchDL;
		private int m_butStopDL;
		private int m_butPiqaDL;
		private int m_chkCaseSensDL;
		private int m_chkSubDL;
		private int m_comboTypeDW;
		private int m_lstVFindingsDH;
		private int m_lstVFindingsDW;
		private int m_lstVFindingsCol2W;
		private double m_lstVFindingsCol1R;
		private double m_lstVFindingsCol3R;
		private int m_butPiqaDT;
		private int m_lblHitsDT;
		private int m_lblPwrdByDL;
		private int m_lblPwrdByDT;
		private int m_lblScansDT;
		private int m_lblSearchingDT;
		private int m_txtFoundDT;
		private int m_txtPathDW;
		private int m_txtScansDT;
		private int m_txtSearchingDW;
		private int m_txtStringDW;
		private System.Windows.Forms.ListView lstVFindings;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolTip toolTipPiQa;
		private int m_txtSearchingDT;

		
		public frmMySearch( string p_StartPath )
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
	
			init( p_StartPath );
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager( typeof( frmMySearch ) );
			this.label1 = new System.Windows.Forms.Label();
			this.butSearch = new System.Windows.Forms.Button();
			this.folderBrowserDialog1 = new System.Windows.Forms.FolderBrowserDialog();
			this.txtString = new System.Windows.Forms.TextBox();
			this.txtPath = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.comboType = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.chkSub = new System.Windows.Forms.CheckBox();
			this.chkCaseSens = new System.Windows.Forms.CheckBox();
			this.txtFound = new System.Windows.Forms.TextBox();
			this.lstVFindings = new System.Windows.Forms.ListView();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.butStop = new System.Windows.Forms.Button();
			this.lblHits = new System.Windows.Forms.Label();
			this.lblSearching = new System.Windows.Forms.Label();
			this.txtSearching = new System.Windows.Forms.TextBox();
			this.lblScans = new System.Windows.Forms.Label();
			this.txtScans = new System.Windows.Forms.TextBox();
			this.lblPwrdBy = new System.Windows.Forms.Label();
			this.butPiqa = new System.Windows.Forms.Button();
			this.imageList1 = new System.Windows.Forms.ImageList( this.components );
			this.toolTipPiQa = new System.Windows.Forms.ToolTip( this.components );
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.label1.Location = new System.Drawing.Point( 10, 14 );
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size( 67, 28 );
			this.label1.TabIndex = 0;
			this.label1.Text = "String";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// butSearch
			// 
			this.butSearch.Cursor = System.Windows.Forms.Cursors.Default;
			this.butSearch.Enabled = false;
			this.butSearch.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.butSearch.Location = new System.Drawing.Point( 1085, 9 );
			this.butSearch.Name = "butSearch";
			this.butSearch.Size = new System.Drawing.Size( 86, 37 );
			this.butSearch.TabIndex = 1;
			this.butSearch.Text = "Search ";
			this.butSearch.Click += new System.EventHandler( this.butSearch_Click );
			// 
			// txtString
			// 
			this.txtString.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.txtString.Location = new System.Drawing.Point( 86, 14 );
			this.txtString.Name = "txtString";
			this.txtString.Size = new System.Drawing.Size( 821, 29 );
			this.txtString.TabIndex = 2;
			this.txtString.TextChanged += new System.EventHandler( this.txtString_TextChanged );
			this.txtString.KeyUp += new System.Windows.Forms.KeyEventHandler( this.txtString_KeyUp );
			// 
			// txtPath
			// 
			this.txtPath.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.txtPath.Location = new System.Drawing.Point( 86, 46 );
			this.txtPath.Name = "txtPath";
			this.txtPath.Size = new System.Drawing.Size( 821, 29 );
			this.txtPath.TabIndex = 3;
			this.txtPath.DoubleClick += new System.EventHandler( this.txtPath_DoubleClick );
			this.txtPath.TextChanged += new System.EventHandler( this.txtPath_TextChanged );
			this.txtPath.KeyUp += new System.Windows.Forms.KeyEventHandler( this.txtPath_KeyUp );
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.label2.Location = new System.Drawing.Point( 10, 48 );
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size( 57, 24 );
			this.label2.TabIndex = 4;
			this.label2.Text = "Path";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// comboType
			// 
			this.comboType.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.comboType.Location = new System.Drawing.Point( 86, 84 );
			this.comboType.Name = "comboType";
			this.comboType.Size = new System.Drawing.Size( 821, 32 );
			this.comboType.TabIndex = 7;
			this.comboType.Text = "comboBox1";
			this.comboType.KeyUp += new System.Windows.Forms.KeyEventHandler( this.comboType_KeyUp );
			this.comboType.TextChanged += new System.EventHandler( this.comboType_TextChanged );
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.label3.Location = new System.Drawing.Point( 10, 88 );
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size( 57, 23 );
			this.label3.TabIndex = 8;
			this.label3.Text = "Type";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// chkSub
			// 
			this.chkSub.Checked = true;
			this.chkSub.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkSub.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.chkSub.Location = new System.Drawing.Point( 917, 46 );
			this.chkSub.Name = "chkSub";
			this.chkSub.Size = new System.Drawing.Size( 158, 28 );
			this.chkSub.TabIndex = 9;
			this.chkSub.Text = "Include Subdirs";
			this.chkSub.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// chkCaseSens
			// 
			this.chkCaseSens.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.chkCaseSens.Location = new System.Drawing.Point( 917, 14 );
			this.chkCaseSens.Name = "chkCaseSens";
			this.chkCaseSens.Size = new System.Drawing.Size( 144, 28 );
			this.chkCaseSens.TabIndex = 10;
			this.chkCaseSens.Text = "Case Sensitive";
			this.chkCaseSens.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtFound
			// 
			this.txtFound.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
			this.txtFound.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.txtFound.Location = new System.Drawing.Point( 278, 803 );
			this.txtFound.Name = "txtFound";
			this.txtFound.Size = new System.Drawing.Size( 92, 29 );
			this.txtFound.TabIndex = 11;
			this.txtFound.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// lstVFindings
			// 
			this.lstVFindings.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( ( ( System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom )
									| System.Windows.Forms.AnchorStyles.Left )
									| System.Windows.Forms.AnchorStyles.Right ) ) );
			this.lstVFindings.Columns.AddRange( new System.Windows.Forms.ColumnHeader[] {
            this.columnHeader3,
            this.columnHeader1,
            this.columnHeader4,
            this.columnHeader2} );
			this.lstVFindings.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.lstVFindings.FullRowSelect = true;
			this.lstVFindings.GridLines = true;
			this.lstVFindings.Location = new System.Drawing.Point( 3, 129 );
			this.lstVFindings.MultiSelect = false;
			this.lstVFindings.Name = "lstVFindings";
			this.lstVFindings.Size = new System.Drawing.Size( 1176, 623 );
			this.lstVFindings.TabIndex = 12;
			this.lstVFindings.UseCompatibleStateImageBehavior = false;
			this.lstVFindings.View = System.Windows.Forms.View.Details;
			this.lstVFindings.DoubleClick += new System.EventHandler( this.lstVFindings_DoubleClick );
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "";
			this.columnHeader3.Width = 1;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "File";
			this.columnHeader1.Width = 288;
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "Line";
			this.columnHeader4.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.columnHeader4.Width = 64;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "String";
			this.columnHeader2.Width = 624;
			// 
			// butStop
			// 
			this.butStop.Enabled = false;
			this.butStop.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.butStop.Location = new System.Drawing.Point( 1085, 60 );
			this.butStop.Name = "butStop";
			this.butStop.Size = new System.Drawing.Size( 86, 37 );
			this.butStop.TabIndex = 13;
			this.butStop.Text = "Stop";
			this.butStop.Click += new System.EventHandler( this.butStop_Click );
			// 
			// lblHits
			// 
			this.lblHits.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
			this.lblHits.Font = new System.Drawing.Font( "Microsoft Sans Serif", 10.2F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.lblHits.Location = new System.Drawing.Point( 230, 803 );
			this.lblHits.Name = "lblHits";
			this.lblHits.Size = new System.Drawing.Size( 44, 28 );
			this.lblHits.TabIndex = 14;
			this.lblHits.Text = "Hits";
			this.lblHits.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblSearching
			// 
			this.lblSearching.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
			this.lblSearching.Font = new System.Drawing.Font( "Microsoft Sans Serif", 10.2F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.lblSearching.Location = new System.Drawing.Point( 5, 762 );
			this.lblSearching.Name = "lblSearching";
			this.lblSearching.Size = new System.Drawing.Size( 129, 27 );
			this.lblSearching.TabIndex = 15;
			this.lblSearching.Text = "Scanning Path";
			this.lblSearching.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtSearching
			// 
			this.txtSearching.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
			this.txtSearching.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.txtSearching.Location = new System.Drawing.Point( 139, 762 );
			this.txtSearching.Name = "txtSearching";
			this.txtSearching.ReadOnly = true;
			this.txtSearching.Size = new System.Drawing.Size( 917, 29 );
			this.txtSearching.TabIndex = 16;
			// 
			// lblScans
			// 
			this.lblScans.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
			this.lblScans.Font = new System.Drawing.Font( "Microsoft Sans Serif", 10.2F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.lblScans.Location = new System.Drawing.Point( 5, 803 );
			this.lblScans.Name = "lblScans";
			this.lblScans.Size = new System.Drawing.Size( 125, 28 );
			this.lblScans.TabIndex = 19;
			this.lblScans.Text = "Files Scanned";
			this.lblScans.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtScans
			// 
			this.txtScans.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
			this.txtScans.Font = new System.Drawing.Font( "Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.txtScans.Location = new System.Drawing.Point( 139, 803 );
			this.txtScans.Name = "txtScans";
			this.txtScans.Size = new System.Drawing.Size( 87, 29 );
			this.txtScans.TabIndex = 18;
			this.txtScans.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// lblPwrdBy
			// 
			this.lblPwrdBy.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right ) ) );
			this.lblPwrdBy.Font = new System.Drawing.Font( "Century Gothic", 10.8F, ( (System.Drawing.FontStyle)( ( System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic ) ) ), System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
			this.lblPwrdBy.Location = new System.Drawing.Point( 808, 815 );
			this.lblPwrdBy.Name = "lblPwrdBy";
			this.lblPwrdBy.Size = new System.Drawing.Size( 276, 27 );
			this.lblPwrdBy.TabIndex = 0;
			this.lblPwrdBy.Text = "Powered by QA Navigation";
			// 
			// butPiqa
			// 
			this.butPiqa.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right ) ) );
			this.butPiqa.BackColor = System.Drawing.Color.SteelBlue;
			this.butPiqa.Image = ( (System.Drawing.Image)( resources.GetObject( "butPiqa.Image" ) ) );
			this.butPiqa.Location = new System.Drawing.Point( 1085, 770 );
			this.butPiqa.Name = "butPiqa";
			this.butPiqa.Size = new System.Drawing.Size( 79, 77 );
			this.butPiqa.TabIndex = 21;
			this.toolTipPiQa.SetToolTip( this.butPiqa, "www.qa-navigation.com" );
			this.butPiqa.UseVisualStyleBackColor = false;
			this.butPiqa.MouseLeave += new System.EventHandler( this.butPiqa_MouseLeave );
			this.butPiqa.Click += new System.EventHandler( this.butPiqa_Click );
			this.butPiqa.MouseEnter += new System.EventHandler( this.butPiqa_MouseEnter );
			// 
			// imageList1
			// 
			this.imageList1.ImageStream = ( (System.Windows.Forms.ImageListStreamer)( resources.GetObject( "imageList1.ImageStream" ) ) );
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			this.imageList1.Images.SetKeyName( 0, "Q.bmp" );
			this.imageList1.Images.SetKeyName( 1, "Q.bmp" );
			// 
			// toolTipPiQa
			// 
			this.toolTipPiQa.AutoPopDelay = 5000;
			this.toolTipPiQa.InitialDelay = 50;
			this.toolTipPiQa.ReshowDelay = 10;
			// 
			// frmMySearch
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size( 6, 15 );
			this.ClientSize = new System.Drawing.Size( 1186, 856 );
			this.Controls.Add( this.butPiqa );
			this.Controls.Add( this.lblPwrdBy );
			this.Controls.Add( this.lblScans );
			this.Controls.Add( this.txtScans );
			this.Controls.Add( this.txtSearching );
			this.Controls.Add( this.txtFound );
			this.Controls.Add( this.chkSub );
			this.Controls.Add( this.txtPath );
			this.Controls.Add( this.txtString );
			this.Controls.Add( this.lblSearching );
			this.Controls.Add( this.lblHits );
			this.Controls.Add( this.butStop );
			this.Controls.Add( this.lstVFindings );
			this.Controls.Add( this.chkCaseSens );
			this.Controls.Add( this.label3 );
			this.Controls.Add( this.comboType );
			this.Controls.Add( this.label2 );
			this.Controls.Add( this.butSearch );
			this.Controls.Add( this.label1 );
			this.Icon = ( (System.Drawing.Icon)( resources.GetObject( "$this.Icon" ) ) );
			this.MinimumSize = new System.Drawing.Size( 622, 415 );
			this.Name = "frmMySearch";
			this.Text = "QA Navigation - MySearch";
			this.Shown += new System.EventHandler( this.frmMySearch_Shown );
			this.Resize += new System.EventHandler( this.frmMySearch_Resize );
			this.ResumeLayout( false );
			this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main( string[] args ) 
		{

			string strtPth = "";

			if( args.Length > 0 ) {

					strtPth = args[0];
			}

			Application.Run(new frmMySearch( strtPth ));
		}

		// --------------------------
		private void checkRun() {

			if( (txtString.Text.Length > 0) && (txtPath.Text.Length > 0 ) ) {

				butSearch.Enabled = true;
			}
		}

		// --------------------------------------------------------------
		/// <summary>
		/// Determines whether the file type was changed.
		/// </summary>
		private void chkTypeChg() {

			if( m_TypeChg ) {

				string newType = comboType.Text;

				comboType.Items.Insert( 0, newType );

				string[] para = new string[]{ "", "" };
				m_EditArgLst.Insert( 0, para );

				m_TypeChg = false;
			}
		}

		// --------------------------------------------------------------
		/// <summary>
		/// Initialize the application.
		/// </summary>
		/// <param name="p_StartPath"></param>
		private void init( string p_StartPath ) {

			int x, y, pos;
			
			string iPth;
			string oPth;
			string line;

			string[] args;

			string tfn;
			
			m_EditArgLst = new ArrayList();

			StreamReader sr;

			m_TypeChg = false;
			m_LastTypeIx = -1;

			// Get Version Info

			object[] attrList;
			string info;

            frmMySearch.CheckForIllegalCrossThreadCalls = false;

			//Assembly asm = Assembly.GetExecutingAssembly( );

			Assembly asm = Assembly.GetCallingAssembly();

			attrList = asm.GetCustomAttributes(typeof(AssemblyTitleAttribute), true);
			AssemblyTitleAttribute aTa = (AssemblyTitleAttribute)attrList[0];
			info = aTa.Title;

			AssemblyName asmName = asm.GetName();
			info += " V" + asmName.Version;

			this.Text = info;

			// Prepare for resize
			x = this.Width;
			y = this.Height;

			m_txtStringDW = x - txtString.Width;
			m_txtPathDW = x - txtPath.Width;
			m_comboTypeDW = x - comboType.Width;

			m_chkCaseSensDL = x - chkCaseSens.Left;
			m_chkSubDL = x - chkSub.Left;

			m_butSearchDL = x - butSearch.Left;
			m_butStopDL = x - butStop.Left;

			// resizing stuff
			m_lstVFindingsDH = y - lstVFindings.Height;
			m_lstVFindingsDW = x - lstVFindings.Width;
			m_lstVFindingsCol2W = lstVFindings.Columns[2].Width;
			//m_lstVFindingsCol1R = Convert.ToDouble(lstVFindings.Columns[1].Width) / x;
			//m_lstVFindingsCol3R = Convert.ToDouble(lstVFindings.Columns[3].Width) / x;
			m_lstVFindingsCol1R = Convert.ToDouble( x ) / lstVFindings.Columns[1].Width;
			m_lstVFindingsCol3R = Convert.ToDouble( x ) / lstVFindings.Columns[3].Width;

			m_butPiqaDT = y - butPiqa.Top;
			m_butPiqaDL = x - butPiqa.Left;
			m_lblHitsDT = y - lblHits.Top;
			m_lblPwrdByDT = y - lblPwrdBy.Top;
			m_lblPwrdByDL = x - lblPwrdBy.Left;
			m_lblScansDT = y - lblScans.Top;
			m_lblSearchingDT = y - lblSearching.Top;
			m_txtFoundDT = y - txtFound.Top;
			m_txtScansDT = y - txtScans.Top;
			m_txtSearchingDT = y - txtSearching.Top;
			m_txtSearchingDW = x - txtSearching.Width;

			// get the file type list & editor settings

			args = Environment.GetCommandLineArgs();
			
			pos = args[0].LastIndexOf('\\');
			oPth = args[0].Substring( 0, pos + 1 );

			tfn = oPth + "MySearchTypes.lst";

			if( p_StartPath.Length < 3 ) {

				iPth = System.Environment.CurrentDirectory; 
			}
			else {

				iPth = p_StartPath;
			}

			if( File.Exists( tfn ) ) {

				sr = new StreamReader( tfn );

				line = sr.ReadLine();

				while( line != null ) {

					if( line.IndexOf( "//" ) > -1 ) {

						line = sr.ReadLine();
					}
					else {

						addPara( ref line );

						line = sr.ReadLine();
					}
				}

				sr.Close();
			}

			line = "*.*";

			addPara( ref line );

			comboType.SelectedIndex = 0;

			txtPath.Text = iPth;
		}


		// --------------------------------------
		private void addPara( ref string p_PLine ) {
			
			int pos1, pos2;

			string edAppl;
			string edPara;
			string types;
			
			string[] para;

			edAppl = "";
			edPara = "";
			types = p_PLine;

			pos1 = p_PLine.IndexOf( '$' );
			pos2 = p_PLine.IndexOf( '$', pos1 + 1 );

			if( pos1 > -1 ) {

				types = p_PLine.Substring( 0, pos1 );

				if( pos2 > -1 ) {

					edAppl = p_PLine.Substring( pos1 + 1, pos2 - pos1 - 1 );

					edPara = p_PLine.Substring( pos2 + 1 );
				}
				else {

					edAppl = p_PLine.Substring( pos1 + 1 );
				}
			}

			para = new string[]{ edAppl, edPara };
			m_EditArgLst.Add( para );

			comboType.Items.Add( types );
		}

		// --------------------------------------------------------------
		/// <summary>
		/// Checks if a search string and a path has been specified.
		/// </summary>
		/// <returns>bool</returns>
		private bool readyToGo() {

			bool ready = false;

			if( ( txtPath.Text.Length > 0  ) && ( txtString.Text.Length > 0 ) ) {

				ready = true;
			}

			butSearch.Enabled = ready;

			return ready;
		}

		// --------------------------------------------------------------
		/// <summary>
		/// Scan the files and the subpaths (if requested).
		/// </summary>
		/// <param name="p_Str"></param>
		/// <param name="p_Pth"></param>
		/// <param name="p_PatLst"></param>
		/// <param name="p_WithSub"></param>
		/// <param name="p_Pl"></param>
		/// <param name="p_CaseSens"></param>
		private void scanPath( string p_Str, string p_Pth, string[] p_PatLst, bool p_WithSub, int p_Pl, bool p_CaseSens ) {

			int i, j, x, y;

			int ix;

			int lineCnt;

			string line;
			string sLine;
			string fileName;
			string pattern;
			string[] fileLst;

			StreamReader fReader;
			ListViewItem anItem;
			//string[] viewLine;

			try {

				txtSearching.Text = p_Pth;
				txtSearching.Refresh();

				x = p_PatLst.Length;

				for( i = 0; ( i < x ) && m_Cont; ++i ) {

					pattern = p_PatLst[ i ];
					
					fileLst = Directory.GetFiles( p_Pth, pattern );

					y = fileLst.Length;

					for( j = 0; (j < y) && m_Cont; ++j ) {

						try {

							m_Count++;

							txtScans.Text = m_Count.ToString();
							txtScans.Refresh();

							fileName = fileLst[ j ];

							fReader = new StreamReader( fileName );

							line = fReader.ReadLine();

							lineCnt = 0;

							while( (line != null) && m_Cont ) {

								lineCnt++;

								if( !p_CaseSens ) {

									sLine = line.ToLower();
								}
								else {

									sLine = line;
								}

								ix = sLine.IndexOf( p_Str );

								if( ix > -1 ) {

									m_Hits++;

									txtFound.Text = m_Hits.ToString();
									txtFound.Refresh();

									/*
									viewLine = new string[2];

									viewLine[0] = fileName.Substring( p_Pl );
									viewLine[1] = line;
									*/

									anItem = new ListViewItem();

									if( ix > 70 ) {

										line = line.Substring( ix - 30 );
									}
								
									anItem.SubItems.Add( fileName.Substring( p_Pl ) );
									anItem.SubItems.Add( lineCnt.ToString() );
									anItem.SubItems.Add( line );

									lstVFindings.Items.Add( anItem );

									if( m_Hits < 80 ) {

										lstVFindings.Refresh();
									}

									//lstFiles.Items.Add( fileName.Substring( p_Pl ) );
									//lstString.Items.Add( line );
								}
								
								line = fReader.ReadLine();
							}

							fReader.Close();
						}
						catch( Exception exc ) {

							MessageBox.Show( exc.Message, "Exception" );
						}
					}
				}

				if( p_WithSub && m_Cont ) {

					string dir;
					string[] dirLst;

					dirLst = Directory.GetDirectories( p_Pth );

					x = dirLst.Length;

					for( i = 0; (i < x) && m_Cont; ++i ) {

						dir = dirLst[ i ];

						scanPath( p_Str, dir, p_PatLst, p_WithSub, p_Pl, p_CaseSens );
					}
				}
			}
			catch( Exception exc ) {

				MessageBox.Show( exc.Message, "Exception" );
			}
		}

		// --------------------------------------------------------------
		/// <summary>
		/// 
		/// </summary>
		private void startScan() {

			int l;

			string[] patLst;
			string str;

			bool withSub;
			bool caseSens;

			m_Cont = true;

			trimTPth();

			string path = txtPath.Text;

			m_LastPath = path;

			string pats = comboType.Text;

			//string pats = comboType.SelectedItem.ToString();

			str = txtString.Text;

			withSub = chkSub.Checked;
			caseSens = chkCaseSens.Checked;

			if( !caseSens ) {

				str = str.ToLower();
			}

			patLst = pats.Split( ';' );

			l = path.Length;

			if( l > 3 ) {

				l += 1;
			}

			scanPath( str, path, patLst, withSub, l, caseSens );

			butStop.Enabled = false;
			butSearch.Enabled = true;
			
			txtSearching.Text = "";
			txtSearching.Refresh();
		}

		// --------------------------------------------------------------
		private void trimTPth() {

			int l, x;

			l = txtPath.Text.Length;

			if( l < 3 ) {

				txtPath.Text += "\\";
			}

			if( l > 3 ) {

				x = txtPath.Text.LastIndexOf( '\\' );

				if( ( txtPath.Text.Length > 3 ) && (x == (txtPath.Text.Length -1)) ) {

					txtPath.Text = txtPath.Text.Substring( 0, x );
				}
			}
		}

		// --------------------------------------------------------------
		private void butSearch_Click(object sender, System.EventArgs e) {
			
			m_Hits = 0;
			m_Count = 0;

			butSearch.Enabled = false;
			butStop.Enabled = true;

			txtFound.Text = m_Hits.ToString();

			lstVFindings.Items.Clear();

			chkTypeChg();

			//startScan();

			Thread startScanThread = new Thread(new ThreadStart(startScan));

			// Start the thread.
			startScanThread.Start();
		}

		// --------------------------------------------------------------
		private void txtPath_DoubleClick(object sender, System.EventArgs e) {

			folderBrowserDialog1.ShowDialog();

			txtPath.Text = folderBrowserDialog1.SelectedPath;

			readyToGo();
		}

		private void txtString_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e) {
		
			if( e.KeyCode == Keys.Enter ) {

				if( readyToGo() ) {

					butSearch_Click( sender, e );
				}
			}
		}

		// --------------------------------------------------------------
		private void butStop_Click(object sender, System.EventArgs e) {
		
			m_Cont = false;
		}

		// --------------------------------------------------------------
		private void lstVFindings_DoubleClick(object sender, System.EventArgs e) {

			try {

				int idx;

				string cmdStr;
				string file;
				string[] argLst;

				cmdStr = "";

				file = m_LastPath;

				ListView.SelectedIndexCollection sic = lstVFindings.SelectedIndices;

				ListViewItem lvi = lstVFindings.Items[ sic[0] ];
				
				file += "\\" + lvi.SubItems[1].Text;

				idx = comboType.SelectedIndex;

				argLst = (string[])m_EditArgLst[ idx ];

				if( argLst[1].Length > 0 ) {

					// file += " -cursor " + lvi.SubItems[2].Text + ":0"
					cmdStr = String.Format( argLst[1], file, lvi.SubItems[2].Text, "0" ); 
					
					//Process.Start( cmdStr );
				}

				ProcessStartInfo psi = new ProcessStartInfo();

				if( argLst[0].Length > 0 ) {

					psi.FileName = argLst[0];
				}
				else {

					psi.FileName = file;
					psi.Verb = "edit";
				}

				if( cmdStr.Length > 0 ) {

					psi.Arguments = cmdStr;
				}
				else {

					psi.Arguments = file;
				}

				Process.Start( psi );
			}
			catch( Exception exc ) {

				MessageBox.Show( exc.Message, "Exception" );
			}
		}

		// --------------------------------------------------------------
		private void txtPath_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e) {
		
			if( e.KeyCode == Keys.Enter ) {

				if( readyToGo() ) {

					butSearch_Click( sender, e );
				}
			}
		}

		// --------------------------------------------------------------
		private void comboType_TextChanged(object sender, System.EventArgs e) {

			int ix = comboType.SelectedIndex;

			if( (ix == m_LastTypeIx) || (ix == -1) ) {

				m_TypeChg = true;
			}
			else {

				m_TypeChg = false;
			}

			m_LastTypeIx = ix;
		}

		// --------------------------------------------------------------
		private void comboType_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e) {
		
			if( e.KeyCode == Keys.Enter ) {

				if( readyToGo() ) {

					butSearch_Click( sender, e );
				}
			}
		}

		// --------------------------------------------------------------
		private void butPiqa_Click(object sender, System.EventArgs e) {
		
			try {

				ProcessStartInfo psi2 = new ProcessStartInfo( "http://www.qa-navigation.com" );
				psi2.Verb = "open";
				Process.Start( psi2 );
			}
			catch( Exception excp ) {

			}
		}

		// --------------------------------------------------------------
		private void frmMySearch_Resize(object sender, System.EventArgs e) {

			doResize();
		}

		// -------------------------------------------------------------- 
		private void doResize() {
						int x, y, nw, mw;

			y = this.Height;
			x = this.Width;

			txtString.Width = x - m_txtStringDW;
			txtPath.Width = x - m_txtPathDW;
			comboType.Width = x - m_comboTypeDW;

			chkCaseSens.Left = x - m_chkCaseSensDL;
			chkSub.Left = x - m_chkSubDL;

			butSearch.Left = x - m_butPiqaDL;
			butStop.Left = x - m_butStopDL;
			
			lstVFindings.Height = y - m_lstVFindingsDH;
			lstVFindings.Width = x - m_lstVFindingsDW;

			nw = Convert.ToInt32( Convert.ToDouble( x ) / m_lstVFindingsCol1R );

			lstVFindings.Columns[1].Width = nw;

			mw = lstVFindings.Width - nw - m_lstVFindingsCol2W - 4;
			lstVFindings.Columns[3].Width = mw;
			
			lblHits.Top = y - m_lblHitsDT;

			lblScans.Top = y - m_lblScansDT;
			lblSearching.Top = y - m_lblSearchingDT;
			
			txtFound.Top = y - m_txtFoundDT;
			txtScans.Top = y - m_txtScansDT;

			txtSearching.Top = y - m_txtSearchingDT;		
			txtSearching.Width = x - m_txtSearchingDW;
			
			lblPwrdBy.Top = y - m_lblPwrdByDT;
			lblPwrdBy.Left = x - m_lblPwrdByDL;

			butPiqa.Top = y - m_butPiqaDT;
			butPiqa.Left = x - m_butPiqaDL;

		}

		// --------------------------------------------------------------
		private void butPiqa_MouseEnter(object sender, System.EventArgs e) {
		
			//butPiqa.ImageIndex = 1;
			butPiqa.BackColor = Color.DodgerBlue;
		}

		// --------------------------------------------------------------
		private void butPiqa_MouseLeave(object sender, System.EventArgs e) {
		
			//butPiqa.ImageIndex = 0;
			//butPiqa.BackColor = SystemColors.ActiveCaption;
			butPiqa.BackColor = Color.SteelBlue;
		}

		// --------------------------------------------------------------
		private void txtString_TextChanged(object sender, System.EventArgs e) {
		
			checkRun();
		}

		// --------------------------------------------------------------
		private void txtPath_TextChanged(object sender, System.EventArgs e) {
		
			checkRun();
		}

		private void frmMySearch_Shown( object sender, EventArgs e ) {

				doResize();
		}
	}
}
